/* Bones borrowed from Li Zheng's 2014 China Japan visualization
*/

import peasy.*;
import controlP5.*;

PeasyCam cam;
ControlP5 cp5;

int startYear = 2017;
int endYear = 2023;
int startMonth = 0;
int endMonth = 11;
int numRows;
boolean showBox = true;
boolean showLabels = true;

int hHue = 16;
int hSaturation = 240;
int hBright = 200;
int hTrans = 120;

int hsHue = 163;
int hsSaturation = 240;
int hsBright = 180;
int hsTrans = 120;

int lHue = 210;
int lSaturation = 240;
int lBright = 200;
int lTrans = 120;

int tHue = 60;
int tSaturation = 240;
int tBright = 180;
int tTrans = 120;

int oHue = 120;
int oSaturation = 240;
int oBright = 180;
int oTrans = 120;

int iHue = 40;
int iSaturation = 100;
int iBright = 180;
int iTrans = 255;

color hColor = color(hHue, hSaturation, hBright, hTrans);
color hsColor = color(hsHue, hsSaturation, hsBright, hsTrans);
color tColor = color(tHue, tSaturation, tBright, tTrans);
color lColor = color(lHue, lSaturation, lBright, lTrans); 
color oColor = color(oHue, oSaturation, oBright, oTrans);
color iColor = color(iHue, iSaturation, iBright, iTrans);


int totalYear = endYear-startYear+1;

int hCount[][] = new int[totalYear][endMonth+1];
int hsCount[][] =  new int[totalYear][endMonth+1];
int oCount[][] =  new int[totalYear][endMonth+1];
int lCount[][] = new int[totalYear][endMonth+1];
int tCount[][] =  new int[totalYear][endMonth+1];

int hInv[][] = new int[totalYear][endMonth+1];
int hsInv[][] =  new int[totalYear][endMonth+1];
int oInv[][] =  new int[totalYear][endMonth+1];
int lInv[][] = new int[totalYear][endMonth+1];
int tInv[][] =  new int[totalYear][endMonth+1];

int hCountActual[][] = new int[totalYear][endMonth+1];
int hsCountActual[][] =  new int[totalYear][endMonth+1];
int oCountActual[][] =  new int[totalYear][endMonth+1];
int lCountActual[][] = new int[totalYear][endMonth+1];
int tCountActual[][] =  new int[totalYear][endMonth+1];

int hInvActual[][] = new int[totalYear][endMonth+1];
int hsInvActual[][] =  new int[totalYear][endMonth+1];
int oInvActual[][] =  new int[totalYear][endMonth+1];
int lInvActual[][] = new int[totalYear][endMonth+1];
int tInvActual[][] =  new int[totalYear][endMonth+1];

Table table;
//list of Items which will store each row's data as our Item class
ArrayList<Item> items = new ArrayList<Item>();

int X = 1600; //be the same as the size(x);
int Y = 1200; //be the same as the size(y);
int Z = 8000; //peasycam Z depth

int hHeight = 25; 
int hsHeight = 25; 
int oHeight = 25; 
int lHeight = 25; 
int tHeight = 25; 
  
float zBase = 20; 
float zDisplace = 0;
float adjustX = float(X)/(endMonth-startMonth);
float adjustY = float((Y-10))/(totalYear-1);
String[] monthNames = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"};

void setup() {
  size(1600, 1200, P3D);
  cam = new PeasyCam(this, X/2, Y/2, 400, 10000);
  cam.setMinimumDistance(1);//1
  cam.setMaximumDistance(Z);
  
  float fov = PI/8;
  float cameraZ = (height/2.0) / tan(PI/6);
  perspective(fov, float(width)/float(height), cameraZ/10.0, cameraZ*10.0); 

  cp5 = new ControlP5(this);


}
  
void initializeData() {
  
  table = loadTable("monthly.csv", "header");
  numRows = table.getRowCount();
  
  int year = 0;
  int mt = 0;
  //process headphones datad
  for (int i = 0; i < numRows/5; i++) {    
    String materialType = table.getString(i,0);
    int couts = table.getInt(i,2);
    int invTotal = table.getInt(i,3);
    if (couts==0){
      hCount[year][mt] = 0;//
      
    }else {hCount[year][mt] = hHeight*int(log(couts));} //}
    
    if(invTotal== 0) {
      hInv[year][mt] = 0;}
    else{hInv[year][mt] = hHeight * int(log(invTotal));}
    hCountActual[year][mt] = couts;
    hInvActual[year][mt] = invTotal;
    if(i% 12 == 11){
      mt = 0;
    year ++;}
    else{
      mt ++;}
    
    
    
    }
    
  
  year = 0;
  mt = 0;
  //process hs data
  for (int i = numRows/5; i < numRows/5*2; i++) {
    String materialType = table.getString(i,0);
    int couts = table.getInt(i,2);
    int invTotal = table.getInt(i,3);
    if (couts==0){
      hsCount[year][mt] = 0;//
      
    }else {hsCount[year][mt] = hsHeight*int(log(couts));} //}
    
    if(invTotal== 0) {
      hsInv[year][mt] = 0;}
    else{hsInv[year][mt] = hsHeight * int(log(invTotal));}
    
    hsCountActual[year][mt] = couts;
    hsInvActual[year][mt] = invTotal;
    if(i% 12 == 11){
      mt =0;
    year ++;}
    else{
      mt ++;}
  }
    //item = new Item(materialType, coutDate, couts, invTotal);
    
    
  year = 0;
  mt = 0;
  for (int i = numRows/5*2; i < numRows/5*3; i++) {
    String materialType = table.getString(i,0);
    int couts = table.getInt(i,2);
    int invTotal = table.getInt(i,3);
    if (couts==0){
      lCount[year][mt] = 0;//
      
    }else {lCount[year][mt] = lHeight*int(log(couts));} //}
    
    if(invTotal== 0) {
      lInv[year][mt] = 0;}
    else{lInv[year][mt] = lHeight * int(log(invTotal));}
    lCountActual[year][mt] = couts;
    lInvActual[year][mt] = invTotal;
    if(i% 12 == 11){
      mt =0;
    year ++;}
    else{
      mt ++;}
    //item = new Item(materialType, coutDate, couts, invTotal);
    
   
  }
  
  year = 0;
  mt = 0;
  for (int i = numRows/5*3; i < numRows/5*4; i++) {
    String materialType = table.getString(i,0);
    int couts = table.getInt(i,2);
    int invTotal = table.getInt(i,3);
    if (couts==0){
      oCount[year][mt] = 0;//
      
    }else {oCount[year][mt] = oHeight*int(log(couts));} //}
    
    if(invTotal== 0) {
      oInv[year][mt] = 0;}
    else{oInv[year][mt] = oHeight * int(log(invTotal));}
    oCountActual[year][mt] = couts;
    oInvActual[year][mt] = invTotal;
    if(i% 12 == 11){
      mt =0;
    year ++;}
    else{
      mt ++;}
    //item = new Item(materialType, coutDate, couts, invTotal);
    
    
  }
  
  year = 0;
  mt = 0;
  for (int i = numRows/5*4; i < numRows; i++) {
    String materialType = table.getString(i,0);
    int couts = table.getInt(i,2);
    int invTotal = table.getInt(i,3);
    if (couts==0){
      tCount[year][mt] = 0;//
      
    }else {tCount[year][mt] = tHeight*int(log(couts));} //}
    
    if(invTotal == 0) {
      tInv[year][mt] = 0;}
    else{tInv[year][mt] = tHeight * int(log(invTotal));}
    tCountActual[year][mt] = couts;
    tInvActual[year][mt] = invTotal;
    if(i% 12 == 11){
      mt =0;
    year ++;}
    else{
      mt ++;}
    //item = new Item(materialType, coutDate, couts, invTotal);
    
    
  }
  
}

  
void drawHeadphones() {
  
  float z1, z2, z3, z4, x1, x2, y1, y2;

  hColor = color(hHue, hSaturation, hBright, hTrans);
  fill(hColor);
  
  for (int i = 0; i < endMonth; i++) {
    for (int j = 0; j < totalYear - 1; j++) {
      beginShape(QUADS);
      z1 = min(hCount[j][i], Z)+zBase;
      z2 = min(hCount[j+1][i], Z)+zBase;
      z3 = min(hCount[j+1][i+1], Z)+zBase;
      z4 = min(hCount[j][i+1], Z)+zBase;

      x1 = (i-startMonth)*adjustX;
      x2 = (i-startMonth+1)*adjustX;
      y1 = j*adjustY;
      y2 = (j+1)*adjustY;
      vertex(x1, y1, z1);
      vertex(x1, y2, z2);
      vertex(x2, y2, z3);
      vertex(x2, y1, z4);
      endShape();
      
      
    }
  }
}

void drawHotSpots() {
  
  float z1, z2, z3, z4, x1, x2, y1, y2;
  zDisplace = 350;
  hsColor = color(hsHue, hsSaturation, hsBright, hsTrans);
  fill(hsColor);
  
  for (int i = 0; i < endMonth; i++) {
    for (int j = 0; j < totalYear - 1; j++) {
      beginShape(QUADS);
      z1 = min(hsCount[j][i], Z)+zBase+zDisplace;
      z2 = min(hsCount[j+1][i], Z)+zBase+zDisplace;
      z3 = min(hsCount[j+1][i+1], Z)+zBase+zDisplace;
      z4 = min(hsCount[j][i+1], Z)+zBase+zDisplace;

      x1 = (i-startMonth)*adjustX;
      x2 = (i-startMonth+1)*adjustX;
      y1 = j*adjustY;
      y2 = (j+1)*adjustY;
      vertex(x1, y1, z1);
      vertex(x1, y2, z2);
      vertex(x2, y2, z3);
      vertex(x2, y1, z4);
      endShape();
      
     
    }
  }
}

void drawLaptops() {
  
  float z1, z2, z3, z4, x1, x2, y1, y2;

  lColor = color(lHue, lSaturation, lBright, lTrans);
  fill(lColor);
  zDisplace = 750;
  for (int i = 0; i < endMonth; i++) {
    for (int j = 0; j < totalYear - 1; j++) {
      beginShape(QUADS);
      z1 = min(lCount[j][i], Z)+zBase+zDisplace;
      z2 = min(lCount[j+1][i], Z)+zBase+zDisplace;
      z3 = min(lCount[j+1][i+1], Z)+zBase+zDisplace;
      z4 = min(lCount[j][i+1], Z)+zBase+zDisplace;

      x1 = (i-startMonth)*adjustX;
      x2 = (i-startMonth+1)*adjustX;
      y1 = j*adjustY;
      y2 = (j+1)*adjustY;
      vertex(x1, y1, z1);
      vertex(x1, y2, z2);
      vertex(x2, y2, z3);
      vertex(x2, y1, z4);
      endShape();
    }
  }
}


void drawOther() {
  zDisplace = 1100;
  float z1, z2, z3, z4, x1, x2, y1, y2;

  oColor = color(oHue, oSaturation, oBright, oTrans);
  fill(oColor);
  
  for (int i = 0; i < endMonth; i++) {
    for (int j = 0; j < totalYear - 1; j++) {
      beginShape(QUADS);
      z1 = min(oCount[j][i], Z)+zBase+zDisplace;
      z2 = min(oCount[j+1][i], Z)+zBase+zDisplace;
      z3 = min(oCount[j+1][i+1], Z)+zBase+zDisplace;
      z4 = min(oCount[j][i+1], Z)+zBase+zDisplace;
     
      x1 = (i-startMonth)*adjustX;
      x2 = (i-startMonth+1)*adjustX;
      y1 = j*adjustY;
      y2 = (j+1)*adjustY;
      vertex(x1, y1, z1);
      vertex(x1, y2, z2);
      vertex(x2, y2, z3);
      vertex(x2, y1, z4);
      endShape();
      
    }
  }
  //text("Other", 0, CENTER, zDisplace);
}

void drawTablets() {
  
  float z1, z2, z3, z4, x1, x2, y1, y2;
  zDisplace = 1450;
  tColor = color(tHue, tSaturation, tBright, tTrans);
  fill(tColor);
  
  for (int i = 0; i < endMonth; i++) {
    for (int j = 0; j < totalYear - 1; j++) {
      beginShape(QUADS);
      z1 = min(tCount[j][i], Z)+zBase+zDisplace;
      z2 = min(tCount[j+1][i], Z)+zBase+zDisplace;
      z3 = min(tCount[j+1][i+1], Z)+zBase+zDisplace;
      z4 = min(tCount[j][i+1], Z)+zBase+zDisplace;

      x1 = (i-startMonth)*adjustX;
      x2 = (i-startMonth+1)*adjustX;
      y1 = j*adjustY;
      y2 = (j+1)*adjustY;
      vertex(x1, y1, z1);
      vertex(x1, y2, z2);
      vertex(x2, y2, z3);
      vertex(x2, y1, z4);
      endShape();
      
    }
  }
}

void drawInv() {
  
  int k = 0;
  zDisplace = 350;
  fill(iColor);
  float z1, z2, z3, z4, x1, x2, y1, y2;
  for (int i = 0; i < endMonth; i++) {
    for (int j = 0; j < totalYear - 1; j++) {
      k = 0;
      beginShape(QUADS);
          z1 = min(hInv[j][i], Z)+zBase+zDisplace*k;
          z2 = min(hInv[j+1][i], Z)+zBase+zDisplace*k;
          z3 = min(hInv[j+1][i+1], Z)+zBase+zDisplace*k;
          z4 = min(hInv[j][i+1], Z)+zBase+zDisplace*k;
    
          x1 = (i-startMonth)*adjustX;
          x2 = (i-startMonth+1)*adjustX;
          y1 = j*adjustY;
          y2 = (j+1)*adjustY;
          vertex(x1, y1, z1);
          vertex(x1, y2, z2);
          vertex(x2, y2, z3);
          vertex(x2, y1, z4);
          endShape();
      k ++;
      beginShape(QUADS);
          z1 = min(hsInv[j][i], Z)+zBase+zDisplace*k;
          z2 = min(hsInv[j+1][i], Z)+zBase+zDisplace*k;
          z3 = min(hsInv[j+1][i+1], Z)+zBase+zDisplace*k;
          z4 = min(hsInv[j][i+1], Z)+zBase+zDisplace*k;
    
          x1 = (i-startMonth)*adjustX;
          x2 = (i-startMonth+1)*adjustX;
          y1 = j*adjustY;
          y2 = (j+1)*adjustY;
          vertex(x1, y1, z1);
          vertex(x1, y2, z2);
          vertex(x2, y2, z3);
          vertex(x2, y1, z4);
          endShape();
       k ++;
      beginShape(QUADS);
          z1 = min(lInv[j][i], Z)+zBase+zDisplace*k;
          z2 = min(lInv[j+1][i], Z)+zBase+zDisplace*k;
          z3 = min(lInv[j+1][i+1], Z)+zBase+zDisplace*k;
          z4 = min(lInv[j][i+1], Z)+zBase+zDisplace*k;
    
          x1 = (i-startMonth)*adjustX;
          x2 = (i-startMonth+1)*adjustX;
          y1 = j*adjustY;
          y2 = (j+1)*adjustY;
          vertex(x1, y1, z1);
          vertex(x1, y2, z2);
          vertex(x2, y2, z3);
          vertex(x2, y1, z4);
          endShape();
       k ++;
      beginShape(QUADS);
          z1 = min(oInv[j][i], Z)+zBase+zDisplace*k;
          z2 = min(oInv[j+1][i], Z)+zBase+zDisplace*k;
          z3 = min(oInv[j+1][i+1], Z)+zBase+zDisplace*k;
          z4 = min(oInv[j][i+1], Z)+zBase+zDisplace*k;
    
          x1 = (i-startMonth)*adjustX;
          x2 = (i-startMonth+1)*adjustX;
          y1 = j*adjustY;
          y2 = (j+1)*adjustY;
          vertex(x1, y1, z1);
          vertex(x1, y2, z2);
          vertex(x2, y2, z3);
          vertex(x2, y1, z4);
          endShape();
       k ++;
      beginShape(QUADS);
          z1 = min(tInv[j][i], Z)+zBase+zDisplace*k;
          z2 = min(tInv[j+1][i], Z)+zBase+zDisplace*k;
          z3 = min(tInv[j+1][i+1], Z)+zBase+zDisplace*k;
          z4 = min(tInv[j][i+1], Z)+zBase+zDisplace*k;
    
          x1 = (i-startMonth)*adjustX;
          x2 = (i-startMonth+1)*adjustX;
          y1 = j*adjustY;
          y2 = (j+1)*adjustY;
          vertex(x1, y1, z1);
          vertex(x1, y2, z2);
          vertex(x2, y2, z3);
          vertex(x2, y1, z4);
          endShape();
      
    }
  }
}


void draw() {
  background(255);
  colorMode(HSB, 255);
  initializeData();

  drawHeadphones();
  drawHotSpots();
  drawLaptops();
  drawTablets();
  drawOther();
  drawInv();
  drawMouseLabels();
  pushMatrix();
  textSize(30);
  drawLabels();
  popMatrix();
}

void drawLabels() {
 
 zDisplace = 350;
 int offset = int(zDisplace/3);
 
    int ticks = 10;
    for (int i = 0; i <= totalYear - 1; i++) {
    fill(0);
    text(i+2017, -50, i*adjustY+10);
    }
    //draw X
    float adjustX = float(X)/(endMonth-startMonth);
    for (int i = startMonth; i <= endMonth; i++) {
      fill(0);
      textAlign(CENTER);
      textSize(30);
      text(monthNames[i], (i-startMonth)*adjustX, Y+2*ticks);
    
  }
  textSize(40);
  text("Months", X/2, Y+50, 0);
  text("Tablets", -200, Y/2-40, zDisplace*4+offset);
  text("Other", -200, Y/2-20, zDisplace*3+offset);
  text("Laptops", -200, Y/2, zDisplace*2+offset);
  text("Hot Spots", -200, Y/2+20, zDisplace+offset);
  text("Headphones", -200, Y/2+40, offset);
  
}


void drawMouseLabels() {
  int zDisplace = 350;
  int zBase = 20;
  table = loadTable("monthly.csv", "header");
  numRows = table.getRowCount();
  
  int [][][] coutValues = {hCountActual, hsCountActual, lCountActual, oCountActual, tCountActual};
  int [][][] invValues =  {hInvActual, hsInvActual, lInvActual, oInvActual, tInvActual};
  
  int [][][] coutHeights = {hCount, hsCount, lCount, oCount, tCount};
  int [][][] invHeights =  {hInv, hsInv, lInv, oInv, tInv};
  for (int i=0; i<totalYear; i++){ 
    for (int j=0; j<endMonth-startMonth; j++) {
      for (int k=0; k<5; k++) {
        int countZ = coutHeights[k][i][j] + zBase*k + zDisplace * k;
        int invZ = invHeights[k][i][j] + zBase*k + zDisplace * k;
        int coutValue = coutValues[k][i][j];
        int invValue = invValues[k][i][j];
      
        float y = i*adjustY;
        float x = j*adjustX;
        int z = max(countZ, invZ);
        
        float mouseObjectDistance = sq(mouseX-screenX(x,y,z)) + sq(mouseY-screenY(x,y,z));
        if (mouseObjectDistance < 35) {
         fill(255);
         textSize(14);
         String label = "Checkouts: " + str(coutValue) + "\n" + "Inventory: " + str(invValue);
         
        hint(DISABLE_DEPTH_TEST);
        cam.beginHUD();
        text(label, mouseX, mouseY);
        cam.endHUD();
        hint(ENABLE_DEPTH_TEST);
        }
      }
    }
  }
}
